<template>
  <div class="vlow-canvas">
    <div class="vlow-canvas-inner">
        <component
            v-for="node in nodes"
            :is="getComponent(node)"
            :key="node.id"
            :proto="getProto(node.type)"
            :content="node"
            :style="{top:node.y+'px', left:node.x+'px'}"
            @start-drag="start_drag(node.id, $event)"
        />
      <Connection
          v-for="connection in connections"
          :key="connection.tgt"
          :connection="connection"
          class="vlow-connection"
      />
    </div>
    <slot name="extra" v-bind:geometry="geometry"></slot>
  </div>
</template>

<script>
import { getRowsInNodeProto } from "../utils.js";
import Node from "./Node.vue"
import Connection, { updateEventName } from "./Connection.vue";
import DecisionTable from "./custom-nodes/DecisionTable.vue";
import Get from "./custom-nodes/Get.vue";
import Observe from "./custom-nodes/Observe.vue";
import Set from "./custom-nodes/Set.vue";
import Event from "./custom-nodes/Event.vue";
import Trigger from "./custom-nodes/Trigger.vue";

var oldx, oldy;

export default {
  props: {
    library: Array,
    nodes: Array
  },
  components: {
    Connection,
    Node,
    DecisionTable,
    Get,
    Observe,
    Set,
    Event,
    Trigger
  },
  data() {
    return {
      curr_id: null
    }
  },
  methods: {
    start_drag (id, e) {
      this.$el.addEventListener("mousemove", this.do_drag)
      this.$el.addEventListener("mouseup", this.end_drag)
      this.curr_id = id
      oldx = e.x
      oldy = e.y
    },
    do_drag (e) {
      let i = this.nodes.findIndex(node=>node.id===this.curr_id)

      this.nodes[i].x += (e.x - oldx)
      this.nodes[i].y += (e.y - oldy)

      oldx = e.x
      oldy = e.y

      this.$nextTick(()=>
        this.dispatchUpdateEvent()
      )

    },
    end_drag () {
      this.$el.removeEventListener("mousemove", this.do_drag)
      this.$el.removeEventListener("mouseup", this.end_drag)
    },
    getProto(type) {
      return this.library.find(node => node.id === type)
    },
    getComponent(node) {
      const name = `custom-node-${node.type}`
      var bla = Object.entries(this.$options.components).find(([, comp]) => comp.name === name )
      return bla ? bla[0] : "Node"
    },
    dispatchUpdateEvent() {
      if (window) {
        window.dispatchEvent(new window.Event(updateEventName))
      }
    }
  },
  computed: {
    connections() {
      return this.nodes.flatMap(node => Object.entries(node.node)
          .filter(([, {type}]) => type === "connection")
          .map(([pin, {connection}]) => ({
            src: `[rel='${connection.source}']>[rel='${connection.pin}']`,
            tgt: `[rel='${node.id}']>[rel='${pin}']`
          }))
      )
    },
    geometry() {
      return this.nodes.map(node => ({
        y: node.y,
        rows: getRowsInNodeProto(this.getProto(node.type)),
        height: node.height
      }))
    }
  },
  mounted: function () {
    if (document) {
      if (document.readyState === 'complete') {
        this.dispatchUpdateEvent()
      } else {
        document.onreadystatechange = () => {
          if (document.readyState === 'complete') {
            this.dispatchUpdateEvent()
          }
        }
      }
    }
  },
}
</script>

<style lang="scss">
  .vlow-canvas {
    position: relative;
    .vlow-canvas-inner {
      position: absolute;
      left: 50%;
      display: block;
      right: 0;
      top: 0;
      bottom: 0;
    }
    .vlow-node, .vlow-connection {
      position: absolute;
      z-index: 9001;
    }
  }
</style>
